#!/usr/bin/perl -w

# literal hash of greeting-strings, keyed by dialect
%greetings = ('english' => 'Hello!',  'deutsch' => 'Tag!');

print "What is your favorite dialect? ";
while ($dialect = <STDIN>) {
  chomp ($dialect);
  if (exists($greetings{$dialect})) {        # existence check
    print $greetings{$dialect}, "\n";        # hash lookup
  }
  else {
    print ("Sorry, I don't speak '$dialect' ",
           " -- how should I greet you? ");
    $greeting = <STDIN>;
    chomp ($greeting);
    $greetings{$dialect} = $greeting;        # hash assignmentg
    print "Well, then -- ", $greeting, "\n";
  }
  print "What is your next favorite dialect? ";
}

# Summarize what we know
print "\n\nI now know the following greetings:\n";
foreach $dialect (keys(%greetings)) {        # hash iteration
  print "\t $dialect:\t $greetings{$dialect}\n";
}
