#!/usr/bin/perl -w

## -- open the greetings file
open(GREETINGS, "<greetings.txt")
  or die("$0: could not open 'greetings.txt': $!");

## -- read in known greetings
while (<GREETINGS>) {                     # assign to $_
  ($name,$greeting) = split(/\s+/,$_,2);  # ... convert to list
  chomp($name,$greeting);                 # ... chomp() a list
  $greetings{$name} = $greeting;          # ... associate
}
close(GREETINGS);

## -- say hello
print STDERR 'Who are you? ';
$name = <STDIN>;
chomp($name);
if (exists($greetings{$name})) {         # do I know you?
  print STDOUT $greetings{$name}, "\n";  # ... use greeting from file
} else {
  print STDOUT "Nice to meet you, $name!\n";   # default greeting
}
